% The algorithm2e package has the bug (at least in my opinion)
% that it includes a margin on the right side unconditionally, even
% if this should only be present when line numbers are turned on.
% Algorithm2e advances \hskip by 1.5em. We undo this right at the beginning
% of the envirnoment.

\def\MyAwesomeAlgoSkip{}

\DontPrintSemicolon
\SetAlgoHangIndent{1em}
\SetAlgoSkip{MyAwesomeAlgoSkip}

\begin{algorithm}[t]
  \gdef\MyAwesomeAlgoSkip{\vspace{-1em}}
  \addtolength{\hsize}{1.5em}%
  $T' \leftarrow \{1, \ldots, T\}$;
  $\lambda \leftarrow 0$\;
  \While{not converged}{
    \For{$t \in T'$}{
      \For{$v \in \mathcal{V}_{det}^t$}{
        compute $\SMsgFromFact v$ on $\theta^\lambda$ ;
        $\lambda \leftarrow \lambda + \SMsgFromFact v$\;
      }

      \For{$c \in \mathcal{V}_{conf}^t$}{
        compute $\SMsgFromConf c$ on $\theta^\lambda$;
        $\lambda \leftarrow \lambda + \SMsgFromConf c$\;
      }

      estimate assignment (with primal, optional)\;

      \For{$v \in \mathcal{V}_{det}^t$}{
        compute $\SMsgRight v$ on $\theta^\lambda$ ;
        $\lambda \leftarrow \lambda + \SMsgRight v$
        (backward direction: use $\SMsgLeft v$)
      }
    }
    reverse the order of $T'$\;
  }
  \caption{Dual optimization}
  \label{alg:dual}
\end{algorithm}

% vim: set ts=8 sts=2 sw=2 et:
